nb={}

nb.image="gfx/bomb.png" --bomb sprite on player and on floor
nb.fimage="gfx/fbomb.png" --bomb sprite planted
nb.initposs = { --positions the bomb spawns on
	{38,20},
	{58,18},
	{43,46},
	{49,53},
	{61,70},
	{47,82}
}
nb.initpos=nb.initposs[math.random(1,#nb.initposs)]
nb.btime = 5 --time it takes to plant the bomb
nb.dtime = 5 --time it takes to defuse the bomb
nb.time = 20 --time it takes for the bomb to blow up
nb.dmg = 500 --damage the bomb deals
nb.restartdef = false --restart round upon bomb defuse

nb.bombspots = { --positions you need to plant the bomb on
	{40,3,30},
	{20,33,30}
}

nb.planting = {}
nb.planttimer = {}
nb.bombspotv = {}

nb.defusing = {}
nb.defusetimer = {}

nb.btimer = nb.time

nb.carrier = 0
nb.planter = 0
nb.bombimg = 0

nb.floor = true
nb.fpos = nb.initpos
nb.fimg = image(nb.image,nb.fpos[1]*32+16,nb.fpos[2]*32+16,0)
nb.bimg = 0

nb.rend = false

arrowimg={}

for id=1,32 do
	arrowimg[id]=0
end

function hudtxt(id,colour,text,x,y,align)
	align = align or ""
	local print="\""..colour..text.."\""
	parse("hudtxt "..id.." "..print.." "..x.." "..y.." "..align)
end

function angledir(rot,x,y,factor)
	if rot<-90 then rot=rot+360 end
	local angle=math.rad(math.abs(rot+90))-math.pi
	local cx=x+(math.cos(angle)*factor)
	local cy=y+(math.sin(angle)*factor)
	return cx,cy
end

addhook("use","plantdefbomb")
function plantdefbomb(id)
	for k,bs in pairs(nb.bombspots) do
		if player(id,"tilex")==bs[1] and player(id,"tiley")==bs[2] then
			if not nb.planted then
				if nb.carrier==id then
					msg2(id,"[GAME] Planting bomb...")
					nb.planting[id]=true
					nb.planttimer[id]=5
					nb.bombspotv[id]=k
				end
			else
				if k==nb.bomb.bs and id~=nb.planter then
					msg2(id,"[GAME] Defusing bomb...")
					nb.defusing[id]=true
					nb.defusetimer[id]=5
				end
			end
		end
	end
end

addhook("second","ticktock")
function ticktock()
	for _,id in pairs(player(0,"table")) do
		if nb.planting[id] then
			if nb.planttimer[id]>1 then
				nb.planttimer[id]=nb.planttimer[id]-1
			else
				nb.planttimer[id] = 0
				nb.planting[id] = false
				nb.bombspot(nb.bombspotv[id],id)
				nb.btimer = nb.time
				nb.planter = id
				msg("[GAME] The bomb has been planted!")
				hudtxt(10,"255000000","Time until explosion: "..nb.btimer,5,425)
			end
		end
		if nb.defusing[id] then
			if nb.defusetimer[id]>1 then
				nb.defusetimer[id]=nb.defusetimer[id]-1
			else
				nb.defusetimer[id]=0
				nb.defusing[id]=false
				freeimage(nb.bomb.img)
				nb.btimer=0
				hudtxt(10,"255000000","",5,425)
				msg("[GAME] The bomb has been defused!")
				if nb.restartdef then
					msg("[GAME] "..player(id,"name").." has won the round by defusing the bomb!")
					timer(5000,"parse","restart")
					timer(5100,"parse","setscore "..id.." "..(player(id,"score")+3))
					nb.rend=true
				else
					msg("[GAME] "..player(id,"name").." has defused the bomb!")
					parse("setscore "..id.." "..(player(id,"score")+3))
					timer(5000,"respawnbomb")
				end
				nb.btimer=0
				nb.bomb=nil
				nb.planted=false
			end
		end
		if nb.planted then
			if nb.btimer>1 then
				nb.btimer=nb.btimer-1
				hudtxt(10,"255000000","Time until explosion: "..nb.btimer,5,425)
				freeimage(nb.bomb.led)
				nb.bomb.led = image("gfx/sprites/flare1.bmp",(nb.bombspots[nb.bomb.bs][1]*32+16)-2,(nb.bombspots[nb.bomb.bs][2]*32+16)+6,3)
				imagescale(nb.bomb.led,0.5,0.5)
				imageblend(nb.bomb.led,1)
				imagecolor(nb.bomb.led,255,0,0)
				tween_alpha(nb.bomb.led,1000,0)
			elseif nb.btimer==1 then
				nb.btimer=0
				hudtxt(10,"255000000","Time until explosion: 0!",5,425)
				parse("explosion "..(nb.bombspots[nb.bomb.bs][1]*32+16).." "..(nb.bombspots[nb.bomb.bs][2]*32+16).." "..(nb.bombspots[nb.bomb.bs][3]*32).." "..nb.dmg.." "..nb.bomb.ply)
				msg("[GAME] "..player(nb.bomb.ply,"name").." has won the round by blowing up the bomb!")
				nb.planted=false
				freeimage(nb.bomb.img)
				timer(5000,"parse","restart")
				timer(5100,"parse","setscore "..nb.bomb.ply.." "..(player(nb.bomb.ply,"score")+3))
				freeimage(nb.bomb.led)
				nb.bomb=nil
				nb.rend=true
			end
		end
	end
end

function nb.bombspot(bs,id)
	freeimage(nb.bombimg)
	nb.bomb = {
		img = image(nb.fimage,nb.bombspots[bs][1]*32+16,nb.bombspots[bs][2]*32+16,0),
		bs = bs,
		ply = id,
		led = 0,
	}
	nb.planted = true
end

addhook("move","abortplant")
addhook("attack","abortplant")

function abortplant(id)
	if nb.planting[id] then
		nb.planting[id]=false
		nb.planttimer[id]=0
		msg2(id,"[GAME] Planting aborted")
	end
end

addhook("die","deathoc")
function deathoc(id)
	if id==nb.carrier then
		abortplant(id)
		nb.carrier = 0
		freeimage(nb.bombimg)
		nb.floor = true
		nb.fpos = {player(id,"tilex"),player(id,"tiley")}
		nb.fimg = image(nb.image,nb.fpos[1]*32+16,nb.fpos[2]*32+16,0)
	end
end

addhook("movetile","pickupbomb")
function pickupbomb(id,x,y)
	if x==nb.fpos[1] and y==nb.fpos[2] and nb.floor then
		freeimage(nb.fimg)
		nb.bombimg = image(nb.image,1,0,200+id)
		nb.floor = false
		nb.fpos = {-1,-1}
		nb.carrier = id
	end
end

addhook("startround","respawnbomb")
function respawnbomb()
	nb.carrier = 0
	nb.planter = 0
	nb.floor = true
	nb.initpos=nb.initposs[math.random(1,#nb.initposs)]
	nb.fpos = nb.initpos
	nb.fimg = image(nb.image,nb.fpos[1]*32+16,nb.fpos[2]*32+16,0)
	nb.rend=false
	nb.btimer = nb.time
	hudtxt(10,"255000000","",5,425)
end

addhook("leave","leaveplayer")
function leaveplayer(id)
	nb.carrier = 0
	freeimage(nb.bombimg)
	nb.floor = true
	nb.fpos = {player(id,"tilex"),player(id,"tiley")}
	nb.fimg = image(nb.image,nb.fpos[1]*32+16,nb.fpos[2]*32+16,0)
end